package client;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;

public class ClientB {

	public static void main(String[] args) throws IOException, InterruptedException {
		System.out.println("Starting client...");
		
		//Baue eine Verbindung zu 127.0.0.1::9998 auf.
		Socket socket = new Socket("127.0.0.1", 9998);
		System.out.println("Connected to server.");
	
		//Ertelle einen Thread der solange alles liest was der server schreibt,
		//Bis die Verbindung unterbrochen wird.
		ClientReaderTask readerTask = new ClientReaderTask(socket);
		Thread readerThread = new Thread(readerTask);
		readerThread.start();
		
		// Erstelle einen PrintWriter, der in den output des sockets schreibt
		PrintWriter writer = new PrintWriter(socket.getOutputStream());
		// Schreibe die Nachricht in den PrintWriter
		writer.println("Hallo ich bin ein client.");
		// Sende die Nachricht
		writer.flush();
		System.out.println("Sent my message.");

		// Warte 5 Sekunden
		Thread.sleep(5000);

		// Schliesse die Verbindung.
		socket.close();
		System.out.println("Client shut down.");
	}
	
	private static class ClientReaderTask implements Runnable {
		
		private Socket socket;
		
		public ClientReaderTask(Socket socket) {
			this.socket = socket;
		}
		
		@Override
		public void run() {
			try {
				//Initialisiere einen 'Leser', der aus dem Input liest, der von dem server kommt.
				BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
				
				//So lange wie die Verbindung besteht (In diesem Fall wird die gelesene Zeile null sein) tue:
				String line;
				while((line = reader.readLine()) != null) {
					//Drucke die antwort des servers
					System.out.println("Answer from server: " + line);
				}
			} catch (IOException e) { }
			System.out.println("Disconnected");
		}
		
	}
	
}
